/* 
 * File:   i2c_portExpander.c
 * Author: chengo_cc
 *
 * Created on 02 January 2016, 7:39 PM
 */

#include <stdio.h>
#include <stdlib.h>
#include <pic.h>
//-------------------------Define i2c pins--------------------------------------
#define SCK	RC3
#define SDA	RC4
//---------------------------DIRECTION------------------------------------------
#define SCK_dir TRISC3			//Clock pin direction
#define SDA_dir TRISC4			//Data pin direction
#define _XTAL_FREQ 4000000
//------------------------------------------------------------------------------
#include "I2C.h"
#include "MCP23017.h"
#include "delay.h"
//----------------------Common Anode 7-Segment data-----------------------------
char data[16] = {0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x98,0x88,0x83,0xC6,0xA1,0x86,0x8E};
/*                  0,   1,   2,   3,   4,   5,   6,   7,   8,   9,   A,   B,   C,   D,   E,   F */
//------------------------------------------------------------------------------
int main(int argc, char** argv)
{
  I2C_init(10000);                       //Give speed in KBps
  EXPANDER_init(0x00,0xFF);              //PortA all Outputs, PortB all Inputs.

  int i = 0;
  while(1)
  {
    if(EXPANDER_read(GPIOB) & I3)     //Read whole port (Port B), then determine logic of input pin 4.
    {
      delay(80);                      //Delay prevents spurous transitions.
      EXPANDER_write(OLATA,data[i++]);
      if(i == 16) i = 0;
    }
    delay(50);
  }

  return (EXIT_SUCCESS);
}
//------------------------------------------------------------------------------